#!/usr/local/bin/perl
    #THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT
    #LAWS OF THE UNITED STATES.  FOR LICENSING INFORMATION CONTACT:
    #
    #Christian Bischof or Lucas Roh, Mathematics and Computer Science Division,    
    #Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL 60439, 
    #{bischof,roh}@mcs.anl.gov.

    require 5;

    $undef = " " x 2000;
    $undef = "";
    $i = 0;
    $gcc = $ARGV[2];
    $expand = $ARGV[3];
    $noinlinelist = $ARGV[4];
    @noinlines = ();
    while ($noinlinelist =~ s/([^,]+),//) { $noinlines{"$1"} = 1; }
    $dirlist = $ARGV[5];
    @dirs = ();
    while ($dirlist =~ s/([^,]+),//) { push(@dirs, "$1"); }
    $list = $ARGV[6];
    while ($list =~ s/(\w+),//) { $ignores{"$1"} = 1; $undef .= "#undef $1\n";}

        chop ($progname = `basename $0`);
        $usage = "usage: $progname filename
    ";



        sub open_file {
            $i = 0;
            while ($i <= $#dirs && !open($_[0], "$dirs[$i]/$file")) {
                $i++;
            }
            if ($i <= $#dirs) {
                $flag = 1;
            }
        }







        sub proc_file {
            local($INC_FILE) = $_[0];
            while (<$INC_FILE>)
            {
                if (/^\s*#\s*include\s*<(.+)>\s*\/\*/ ||
                    /^\s*#\s*include\s*<(.+)>/)
                {
                    local($file) = $1;
                    $n++;
                    $out = "char* g_ad_SYSTEM_INCLUDE_BEGIN$n = \"$file\";\n";
                    if ($gcc) {
                        $out .= $_;
                        $out .= $redefs;
                    }
                    else {
                        if ($headers{$file} == 0) {
                            $headers{$file} = $n;
                        }
                       $out .= "#if !defined(g_ad_INCLUDE_FILE_$headers{$file})\n";
                        $out .= "#define g_ad_INCLUDE_FILE_$headers{$file}\n";
                        $out .= $_;
                        $out .= "#endif\n";
                        $out .= $undef;
                    }
                    $out .= "char* g_ad_SYSTEM_INCLUDE_END$n = \"$file\";\n";
                    $_ = $out;
                }
                elsif (/^\s*#\s*include\s*"(.+)"\s*\/\*/ ||
                       /^\s*#\s*include\s*"(.+)"/)
                {
                    local($file) = $1;
                    $n++;
                    local($locn) = $n;
                    $out = "char* g_ad_USER_INCLUDE_BEGIN$locn = \"$file\";\n";
                    print OUT_FILE $out;
                    if ($noinlines{$file} || ($gcc && !$expand)) {
                        $_ .= $redefs;
                        print OUT_FILE $_;
                    }
                    else {
                        if ($headers2{$file} != 1) {
                            $headers2{$file} = 1;
                            $flag = 0;
                            local(*NEW_FILE);
                            &open_file(NEW_FILE);
                            if ($flag == 1) {
                                &proc_file(NEW_FILE);
                            }
                            else {
                                print OUT_FILE $_;
                            }
                            $headers2{$file} = 0;
                        }
                        else {
                            print OUT_FILE $_;
                        }
                    }
                    $out = "char* g_ad_USER_INCLUDE_END$locn = \"$file\";\n";
                    $_ = $out;
                } 
                elsif (/^\s*#\s*define\s*([a-zA-Z_]+)/)
                {
                    if ($ignores{"$1"} == 1) {
                        $n++;
                        local($locn) = $n;
                        if (/\\$/) {
                            do {
                                chop;
                                chop;
                                $tmp = $_;
                                $_ .= <$INC_FILE>;
                            } while (/\\$/);
                        }
                        chop;
                        s/"/\\"/g;
                        $_ = "char* g_ad_USER_DEFINE_DEF$locn = \"$_\";\n";
                    }
                } 
                elsif (/\/\*\*\s*PRAGMA\s*(.+)\s*(.+)\s*\*\*\//) {
                    local($prag) = $1;
                    local($val) = $2;
                    $n++;
                    local($locn) = $n;

                    if ($prag =~ /HAD-BB/) {
                        $val =~ s/in\((.+)\)\s+out\((.+)\)\s*/double ad_PRAGMA_$prag_in_$locn = $1;\ndouble ad_PRAGMA_$prag_out_$locn = $2;\n/;
                    }
                    $_ = $val;
                }
                print OUT_FILE $_;
            }
        }







        open(INPUT_FILE, "$ARGV[0]") || die "Cannot open source: \"$ARGV[0]\"\n";
        open(OUT_FILE, ">$ARGV[1]") || die "Error: cannot open $ARGV[1] for writing.\n";
        $n = 0;
        if ($ARGV[7] ne "") {
            open(MAC_FILE, "$ARGV[7]") || die "Error: cannot open $ARGV[7] for reading.\n";
                $out = "char* g_ad_SYSTEM_INCLUDE_BEGIN$n = \"\";\n";
                print OUT_FILE $out;
                while (<MAC_FILE>) {
                    print OUT_FILE $_;
                }
                if ($gcc) {
                    print OUT_FILE "#define __attribute__(x)\n";
                    print OUT_FILE "typedef short unsigned int __wchar_t;\n";
                }
                    $redefs = " " x 2000;
                    $redefs = "";
                    if ($gcc) {
                        while (($def,$value) = each %ignores) {
                            $redefs .= "#if defined($def)\n";
                            $redefs .= "#undef $def\n#define $def $def\n";
                            $redefs .= "#endif\n";
                        }
                    }



                $out = "char* g_ad_SYSTEM_INCLUDE_END$n = \"\";\n";
                print OUT_FILE $out;
                $n++;


        }
        &proc_file(INPUT_FILE, $n);




