#include "ad_mpi.h"

int ad_MPI_Init(int *argc, char ***argv)
{
DERIV_TYPE dummy;
MPI_Datatype types[2] = {MPI_DOUBLE,MPI_DOUBLE};
MPI_Aint displacements[2];
int lengths[2] = {1,ad_GRAD_MAX};

int ierr;

ierr = MPI_Init(argc,argv);

if (ierr) {
   printf("Error in MPI initialization.\n");
} 

ierr += MPI_Address(&DERIV_val(dummy),&displacements[0]);
ierr += MPI_Address(&(DERIV_grad(dummy)),&displacements[1]);
displacements[1] -= displacements[0];
displacements[0] = 0;

ierr += MPI_Type_struct(2,lengths,displacements,types,&MPI_DERIV_TYPE);
ierr += MPI_Type_commit(&MPI_DERIV_TYPE);

if (ierr)
   printf("Error in creation of MPI_DERIV_TYPE datatype.\n");

return ierr;
}
