=head1 NAME

LineInFile - keep track of a line and its line number 

=head1 SYNOPSIS

    use LineInFile;
    $line = LineInFile ($line_text, $line_number);

    print $line->LineNumber,": ",$line->Text();

=head1 BUGS

No man page.

=cut

package LineInFile;

# Constants

$LINE = 0;
$LINE_NUMBER = 1;

# new line, line number
sub new {
    my $type = shift;
    my $self = [];
    my ($line, $line_number) = @_;
    $self->[$LINE] = $line;
    $self->[$LINE_NUMBER] = $line_number;
    bless $self, $type;
}


sub Text {
    my $self = shift;
    return $self->[$LINE];
}

sub LineNumber {
    my $self = shift;
    return $self->[$LINE_NUMBER];
}

1;

